<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE mapper PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN"
"mybatis-3-mapper.dtd">
<mapper namespace="com.mortals.xhx.module.access.dao.ibatis.AccessSystemDaoImpl">

    <!-- 字段和属性映射 -->
    <resultMap type="AccessSystemEntity" id="AccessSystemEntity-Map">
            <id  property="id" column="id" />
            <result property="accessId" column="accessId" />
            <result property="systemName" column="system_name" />
            <result property="systemCode" column="system_code" />
            <result property="enabled" column="enabled" />
            <result property="accessTime" column="access_time" />
            <result property="sort" column="sort" />
            <result property="remark" column="remark" />
            <result property="createUserId" column="create_user_id" />
            <result property="createTime" column="create_time" />
            <result property="updateTime" column="update_time" />
            
    </resultMap>


    <!-- 表所有列 -->
    <sql id="_columns">
        <trim suffixOverrides="," suffix="">
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('id') or colPickMode == 1 and data.containsKey('id')))">
                    a.id,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('accessId') or colPickMode == 1 and data.containsKey('accessId')))">
                    a.accessId,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('systemName') or colPickMode == 1 and data.containsKey('systemName')))">
                    a.system_name,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('systemCode') or colPickMode == 1 and data.containsKey('systemCode')))">
                    a.system_code,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('enabled') or colPickMode == 1 and data.containsKey('enabled')))">
                    a.enabled,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('accessTime') or colPickMode == 1 and data.containsKey('accessTime')))">
                    a.access_time,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('sort') or colPickMode == 1 and data.containsKey('sort')))">
                    a.sort,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('remark') or colPickMode == 1 and data.containsKey('remark')))">
                    a.remark,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('createUserId') or colPickMode == 1 and data.containsKey('createUserId')))">
                    a.create_user_id,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('createTime') or colPickMode == 1 and data.containsKey('createTime')))">
                    a.create_time,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('updateTime') or colPickMode == 1 and data.containsKey('updateTime')))">
                    a.update_time,
                </if>
        </trim>
    </sql>
    <!-- 新增 区分主键自增加还是业务插入 -->
    <insert id="insert" parameterType="AccessSystemEntity"  useGeneratedKeys="true" keyProperty="id">
        insert into mortals_xhx_access_system
        (accessId,system_name,system_code,enabled,access_time,sort,remark,create_user_id,create_time,update_time)
        VALUES
        (#{accessId},#{systemName},#{systemCode},#{enabled},#{accessTime},#{sort},#{remark},#{createUserId},#{createTime},#{updateTime})
    </insert>

    <!-- 批量新增 -->
    <insert id="insertBatch" parameterType="paramDto">
        insert into mortals_xhx_access_system
        (accessId,system_name,system_code,enabled,access_time,sort,remark,create_user_id,create_time,update_time)
        VALUES
        <foreach collection="data.dataList" item="item" index="index" separator="," >
            (#{item.accessId},#{item.systemName},#{item.systemCode},#{item.enabled},#{item.accessTime},#{item.sort},#{item.remark},#{item.createUserId},#{item.createTime},#{item.updateTime})
        </foreach>
    </insert>


    <!-- 根据ParamDto更新 -->
    <update id="update" parameterType="paramDto">
        update mortals_xhx_access_system as a
        set
        <trim suffixOverrides="," suffix="">
            <if test="(colPickMode==0 and data.containsKey('accessId')) or (colPickMode==1 and !data.containsKey('accessId'))">
                a.accessId=#{data.accessId},
            </if>
            <if test="(colPickMode==0 and data.containsKey('accessIdIncrement')) or (colPickMode==1 and !data.containsKey('accessIdIncrement'))">
                a.accessId=ifnull(a.accessId,0) + #{data.accessIdIncrement},
            </if>
            <if test="(colPickMode==0 and data.containsKey('systemName')) or (colPickMode==1 and !data.containsKey('systemName'))">
                a.system_name=#{data.systemName},
            </if>
            <if test="(colPickMode==0 and data.containsKey('systemCode')) or (colPickMode==1 and !data.containsKey('systemCode'))">
                a.system_code=#{data.systemCode},
            </if>
            <if test="(colPickMode==0 and data.containsKey('enabled')) or (colPickMode==1 and !data.containsKey('enabled'))">
                a.enabled=#{data.enabled},
            </if>
            <if test="(colPickMode==0 and data.containsKey('enabledIncrement')) or (colPickMode==1 and !data.containsKey('enabledIncrement'))">
                a.enabled=ifnull(a.enabled,0) + #{data.enabledIncrement},
            </if>
            <if test="(colPickMode==0 and data.containsKey('accessTime')) or (colPickMode==1 and !data.containsKey('accessTime'))">
                a.access_time=#{data.accessTime},
            </if>
            <if test="(colPickMode==0 and data.containsKey('sort')) or (colPickMode==1 and !data.containsKey('sort'))">
                a.sort=#{data.sort},
            </if>
            <if test="(colPickMode==0 and data.containsKey('sortIncrement')) or (colPickMode==1 and !data.containsKey('sortIncrement'))">
                a.sort=ifnull(a.sort,0) + #{data.sortIncrement},
            </if>
            <if test="(colPickMode==0 and data.containsKey('remark')) or (colPickMode==1 and !data.containsKey('remark'))">
                a.remark=#{data.remark},
            </if>
            <if test="(colPickMode==0 and data.containsKey('createUserId')) or (colPickMode==1 and !data.containsKey('createUserId'))">
                a.create_user_id=#{data.createUserId},
            </if>
            <if test="(colPickMode==0 and data.containsKey('createUserIdIncrement')) or (colPickMode==1 and !data.containsKey('createUserIdIncrement'))">
                a.create_user_id=ifnull(a.create_user_id,0) + #{data.createUserIdIncrement},
            </if>
            <if test="(colPickMode==0 and data.containsKey('createTime')) or (colPickMode==1 and !data.containsKey('createTime'))">
                a.create_time=#{data.createTime},
            </if>
            <if test="(colPickMode==0 and data.containsKey('updateTime')) or (colPickMode==1 and !data.containsKey('updateTime'))">
                a.update_time=#{data.updateTime},
            </if>
        </trim>
        <trim suffixOverrides="where" suffix="">
            where
            <trim prefixOverrides="and" prefix="">
                <include refid="_condition_"/>
            </trim>
        </trim>
    </update>
    <!-- 批量更新 -->
    <update id="updateBatch" parameterType="paramDto">
        update mortals_xhx_access_system as a
        <trim prefix="set" suffixOverrides=",">
                        <trim prefix="accessId=(case" suffix="ELSE accessId end),">
                            <foreach collection="data.dataList" item="item" index="index" separator="" >
                                <choose>
                                    <when test="(colPickMode==0 and item.containsKey('accessId')) or (colPickMode==1 and !item.containsKey('accessId'))">
                                        when a.id=#{item.id} then #{item.accessId}
                                    </when>
                                    <when test="(colPickMode==0 and item.containsKey('accessIdIncrement')) or (colPickMode==1 and !item.containsKey('accessIdIncrement'))">
                                        when a.id=#{item.id} then ifnull(a.accessId,0) + #{item.accessIdIncrement}
                                    </when>
                                </choose>
                            </foreach>
                        </trim>
                <trim prefix="system_name=(case" suffix="ELSE system_name end),">
                    <foreach collection="data.dataList" item="item" index="index" separator="" >
                        <if test="(colPickMode==0 and item.containsKey('systemName')) or (colPickMode==1 and !item.containsKey('systemName'))">
                            when a.id=#{item.id} then #{item.systemName}
                        </if>
                    </foreach>
                </trim>
                <trim prefix="system_code=(case" suffix="ELSE system_code end),">
                    <foreach collection="data.dataList" item="item" index="index" separator="" >
                        <if test="(colPickMode==0 and item.containsKey('systemCode')) or (colPickMode==1 and !item.containsKey('systemCode'))">
                            when a.id=#{item.id} then #{item.systemCode}
                        </if>
                    </foreach>
                </trim>
                        <trim prefix="enabled=(case" suffix="ELSE enabled end),">
                            <foreach collection="data.dataList" item="item" index="index" separator="" >
                                <choose>
                                    <when test="(colPickMode==0 and item.containsKey('enabled')) or (colPickMode==1 and !item.containsKey('enabled'))">
                                        when a.id=#{item.id} then #{item.enabled}
                                    </when>
                                    <when test="(colPickMode==0 and item.containsKey('enabledIncrement')) or (colPickMode==1 and !item.containsKey('enabledIncrement'))">
                                        when a.id=#{item.id} then ifnull(a.enabled,0) + #{item.enabledIncrement}
                                    </when>
                                </choose>
                            </foreach>
                        </trim>
                <trim prefix="access_time=(case" suffix="ELSE access_time end),">
                    <foreach collection="data.dataList" item="item" index="index" separator="" >
                        <if test="(colPickMode==0 and item.containsKey('accessTime')) or (colPickMode==1 and !item.containsKey('accessTime'))">
                            when a.id=#{item.id} then #{item.accessTime}
                        </if>
                    </foreach>
                </trim>
                        <trim prefix="sort=(case" suffix="ELSE sort end),">
                            <foreach collection="data.dataList" item="item" index="index" separator="" >
                                <choose>
                                    <when test="(colPickMode==0 and item.containsKey('sort')) or (colPickMode==1 and !item.containsKey('sort'))">
                                        when a.id=#{item.id} then #{item.sort}
                                    </when>
                                    <when test="(colPickMode==0 and item.containsKey('sortIncrement')) or (colPickMode==1 and !item.containsKey('sortIncrement'))">
                                        when a.id=#{item.id} then ifnull(a.sort,0) + #{item.sortIncrement}
                                    </when>
                                </choose>
                            </foreach>
                        </trim>
                <trim prefix="remark=(case" suffix="ELSE remark end),">
                    <foreach collection="data.dataList" item="item" index="index" separator="" >
                        <if test="(colPickMode==0 and item.containsKey('remark')) or (colPickMode==1 and !item.containsKey('remark'))">
                            when a.id=#{item.id} then #{item.remark}
                        </if>
                    </foreach>
                </trim>
                        <trim prefix="create_user_id=(case" suffix="ELSE create_user_id end),">
                            <foreach collection="data.dataList" item="item" index="index" separator="" >
                                <choose>
                                    <when test="(colPickMode==0 and item.containsKey('createUserId')) or (colPickMode==1 and !item.containsKey('createUserId'))">
                                        when a.id=#{item.id} then #{item.createUserId}
                                    </when>
                                    <when test="(colPickMode==0 and item.containsKey('createUserIdIncrement')) or (colPickMode==1 and !item.containsKey('createUserIdIncrement'))">
                                        when a.id=#{item.id} then ifnull(a.create_user_id,0) + #{item.createUserIdIncrement}
                                    </when>
                                </choose>
                            </foreach>
                        </trim>
                <trim prefix="create_time=(case" suffix="ELSE create_time end),">
                    <foreach collection="data.dataList" item="item" index="index" separator="" >
                        <if test="(colPickMode==0 and item.containsKey('createTime')) or (colPickMode==1 and !item.containsKey('createTime'))">
                            when a.id=#{item.id} then #{item.createTime}
                        </if>
                    </foreach>
                </trim>
                <trim prefix="update_time=(case" suffix="ELSE update_time end),">
                    <foreach collection="data.dataList" item="item" index="index" separator="" >
                        <if test="(colPickMode==0 and item.containsKey('updateTime')) or (colPickMode==1 and !item.containsKey('updateTime'))">
                            when a.id=#{item.id} then #{item.updateTime}
                        </if>
                    </foreach>
                </trim>
        </trim>
        where id in
        <foreach collection="data.dataList" item="item" index="index" open="(" separator="," close=")">
            #{item.id}
        </foreach>
    </update>
    <!-- 根据主健查询 -->
    <select id="getByKey" parameterType="paramDto" resultMap="AccessSystemEntity-Map">
        select <include refid="_columns"/>
        from mortals_xhx_access_system as a
        where a.id=#{condition.id}
    </select>
    <!-- 根据主健删除 -->
    <delete id="deleteByKey" parameterType="paramDto">
        delete a.* from mortals_xhx_access_system as a where a.id=#{condition.id}
    </delete>
    <!-- 根据主健删除一批，针对单一主健有效 -->
    <delete id="deleteByKeys">
        delete from mortals_xhx_access_system where id in
        <foreach collection="array" item="item" index="index" open="(" separator="," close=")">
            #{item}
        </foreach>
    </delete>
    <!-- 根据主健列表删除一批，针对单一主健有效 -->
    <delete id="deleteByKeyList">
        delete from mortals_xhx_access_system where id in
        <foreach collection="list" item="item" index="index" open="(" separator="," close=")">
            #{item}
        </foreach>
    </delete>

    <!-- 根据对象列表删除一批，针对单一主健有效 -->
    <delete id="deleteByEntityList">
        delete from mortals_xhx_access_system where id in
        <foreach collection="list" item="item" index="index" open="(" separator="," close=")">
            #{item.id}
        </foreach>
    </delete>
    <!-- 根据paramDto删除一批 -->
    <delete id="deleteByMap" parameterType="paramDto">
        delete a.* from mortals_xhx_access_system as a
        <trim suffixOverrides="where" suffix="">
            where
            <trim prefixOverrides="and" prefix="">
                <include refid="_condition_"/>
            </trim>
        </trim>
    </delete>
    <!-- 获取列表 -->
    <select id="getList" parameterType="paramDto" resultMap="AccessSystemEntity-Map">
        select <include refid="_columns"/>
        from mortals_xhx_access_system as a
        <trim suffixOverrides="where" suffix="">
            where
            <trim prefixOverrides="and" prefix="">
                <include refid="_condition_"/>
            </trim>
        </trim>
        <include refid="_orderCols_"/>
    </select>



    <!-- 获取 -->
    <select id="getListCount" parameterType="paramDto" resultType="int">
        select count(1)
        from mortals_xhx_access_system as a
        <trim suffixOverrides="where" suffix="">
            where
            <trim prefixOverrides="and" prefix="">
                <include refid="_condition_"/>
            </trim>
        </trim>
    </select>
    <!-- 条件映射 -->
    <sql id="_condition_">
        <if test="condition != null and !condition.isEmpty()">
            <!-- 条件映射-普通条件 -->
            <include refid="_condition_param_">
                <property name="_conditionParam_" value="condition"/>
                <property name="_conditionType_" value="and"/>
            </include>
            <!-- 条件映射-集合之间使用AND，集合中元素使用OR-(list[0].1 or list[0].2) and (list[1].3 or list[1].4) -->
            <if test="condition.containsKey('andConditionList') and !condition.andConditionList.isEmpty()">
                and
                <foreach collection="condition.andConditionList" open="(" close=")" index="index" item="andCondition" separator=" and ">
                    <trim prefixOverrides="or" prefix="(" suffix=")">
                        <include refid="_condition_param_">
                            <property name="_conditionParam_" value="andCondition"/>
                            <property name="_conditionType_" value="or"/>
                        </include>
                    </trim>
                </foreach>
            </if>
            <!-- 条件映射-集合之间使用OR，集合中元素使用AND-(list[0].1 and list[0].2) or (list[1].3 and list[1].4) -->
            <if test="condition.containsKey('orConditionList') and !condition.orConditionList.isEmpty()">
                and
                <foreach collection="condition.orConditionList" open="(" close=")" index="index" item="orCondition" separator=" or ">
                    <trim prefixOverrides="and" prefix="(" suffix=")">
                        <include refid="_condition_param_">
                            <property name="_conditionParam_" value="orCondition"/>
                            <property name="_conditionType_" value="and"/>
                        </include>
                    </trim>
                </foreach>
            </if>
        </if>
    </sql>
    <!-- 条件映射-代参数 -->
    <sql id="_condition_param_">
        <bind name="conditionParamRef" value="${_conditionParam_}"/>
        <if test="permissionSql != null and permissionSql != ''">
            ${permissionSql}
        </if>

        <if test="conditionParamRef.containsKey('id')">
            <if test="conditionParamRef.id != null">
                ${_conditionType_} a.id=#{${_conditionParam_}.id}
            </if>
        </if>
            <if test="conditionParamRef.containsKey('id')">
                <if test="conditionParamRef.id != null ">
                    ${_conditionType_} a.id = #{${_conditionParam_}.id}
                </if>
                <if test="conditionParamRef.id == null">
                    ${_conditionType_} a.id is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('idList') and conditionParamRef.idList.size() > 0">
                ${_conditionType_} a.id in
                <foreach collection="conditionParamRef.idList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('idNotList') and conditionParamRef.idNotList.size() > 0">
                ${_conditionType_} a.id not in
                <foreach collection="conditionParamRef.idNotList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('idStart') and conditionParamRef.idStart != null">
                ${_conditionType_} a.id <![CDATA[ >= ]]> #{${_conditionParam_}.idStart}
            </if>
            <if test="conditionParamRef.containsKey('idEnd') and conditionParamRef.idEnd != null">
                ${_conditionType_} a.id <![CDATA[ <= ]]> #{${_conditionParam_}.idEnd}
            </if>

            <if test="conditionParamRef.containsKey('accessId')">
                <if test="conditionParamRef.accessId != null ">
                    ${_conditionType_} a.accessId = #{${_conditionParam_}.accessId}
                </if>
                <if test="conditionParamRef.accessId == null">
                    ${_conditionType_} a.accessId is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('accessIdList') and conditionParamRef.accessIdList.size() > 0">
                ${_conditionType_} a.accessId in
                <foreach collection="conditionParamRef.accessIdList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('accessIdNotList') and conditionParamRef.accessIdNotList.size() > 0">
                ${_conditionType_} a.accessId not in
                <foreach collection="conditionParamRef.accessIdNotList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('accessIdStart') and conditionParamRef.accessIdStart != null">
                ${_conditionType_} a.accessId <![CDATA[ >= ]]> #{${_conditionParam_}.accessIdStart}
            </if>
            <if test="conditionParamRef.containsKey('accessIdEnd') and conditionParamRef.accessIdEnd != null">
                ${_conditionType_} a.accessId <![CDATA[ <= ]]> #{${_conditionParam_}.accessIdEnd}
            </if>


            <if test="conditionParamRef.containsKey('systemName')">
                <if test="conditionParamRef.systemName != null and conditionParamRef.systemName != ''">
                    ${_conditionType_} a.system_name like #{${_conditionParam_}.systemName}
                </if>
                <if test="conditionParamRef.systemName == null">
                    ${_conditionType_} a.system_name is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('systemNameList') and conditionParamRef.systemNameList.size() > 0">
                ${_conditionType_} a.system_name in
                <foreach collection="conditionParamRef.systemNameList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('systemNameNotList') and conditionParamRef.systemNameNotList.size() > 0">
                ${_conditionType_} a.system_name not in
                <foreach collection="conditionParamRef.systemNameNotList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>

            <if test="conditionParamRef.containsKey('systemCode')">
                <if test="conditionParamRef.systemCode != null and conditionParamRef.systemCode != ''">
                    ${_conditionType_} a.system_code like #{${_conditionParam_}.systemCode}
                </if>
                <if test="conditionParamRef.systemCode == null">
                    ${_conditionType_} a.system_code is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('systemCodeList') and conditionParamRef.systemCodeList.size() > 0">
                ${_conditionType_} a.system_code in
                <foreach collection="conditionParamRef.systemCodeList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('systemCodeNotList') and conditionParamRef.systemCodeNotList.size() > 0">
                ${_conditionType_} a.system_code not in
                <foreach collection="conditionParamRef.systemCodeNotList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('enabled')">
                <if test="conditionParamRef.enabled != null ">
                    ${_conditionType_} a.enabled = #{${_conditionParam_}.enabled}
                </if>
                <if test="conditionParamRef.enabled == null">
                    ${_conditionType_} a.enabled is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('enabledList') and conditionParamRef.enabledList.size() > 0">
                ${_conditionType_} a.enabled in
                <foreach collection="conditionParamRef.enabledList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('enabledNotList') and conditionParamRef.enabledNotList.size() > 0">
                ${_conditionType_} a.enabled not in
                <foreach collection="conditionParamRef.enabledNotList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('enabledStart') and conditionParamRef.enabledStart != null">
                ${_conditionType_} a.enabled <![CDATA[ >= ]]> #{${_conditionParam_}.enabledStart}
            </if>
            <if test="conditionParamRef.containsKey('enabledEnd') and conditionParamRef.enabledEnd != null">
                ${_conditionType_} a.enabled <![CDATA[ <= ]]> #{${_conditionParam_}.enabledEnd}
            </if>


            <if test="conditionParamRef.containsKey('accessTime')">
                <if test="conditionParamRef.accessTime != null ">
                    ${_conditionType_} a.access_time = #{${_conditionParam_}.accessTime}
                </if>
                <if test="conditionParamRef.accessTime == null">
                    ${_conditionType_} a.access_time is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('accessTimeStart') and conditionParamRef.accessTimeStart != null and conditionParamRef.accessTimeStart!=''">
                ${_conditionType_} a.access_time <![CDATA[ >= ]]> STR_TO_DATE(left(concat(#{${_conditionParam_}.accessTimeStart},' 00:00:00'),19),'%Y-%m-%d %k:%i:%s')
            </if>
            <if test="conditionParamRef.containsKey('accessTimeEnd') and conditionParamRef.accessTimeEnd != null and conditionParamRef.accessTimeEnd!=''">
                ${_conditionType_} a.access_time <![CDATA[ <= ]]> STR_TO_DATE(left(concat(#{${_conditionParam_}.accessTimeEnd},' 23:59:59'),19),'%Y-%m-%d %k:%i:%s')
            </if>
            <if test="conditionParamRef.containsKey('sort')">
                <if test="conditionParamRef.sort != null ">
                    ${_conditionType_} a.sort = #{${_conditionParam_}.sort}
                </if>
                <if test="conditionParamRef.sort == null">
                    ${_conditionType_} a.sort is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('sortList') and conditionParamRef.sortList.size() > 0">
                ${_conditionType_} a.sort in
                <foreach collection="conditionParamRef.sortList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('sortNotList') and conditionParamRef.sortNotList.size() > 0">
                ${_conditionType_} a.sort not in
                <foreach collection="conditionParamRef.sortNotList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('sortStart') and conditionParamRef.sortStart != null">
                ${_conditionType_} a.sort <![CDATA[ >= ]]> #{${_conditionParam_}.sortStart}
            </if>
            <if test="conditionParamRef.containsKey('sortEnd') and conditionParamRef.sortEnd != null">
                ${_conditionType_} a.sort <![CDATA[ <= ]]> #{${_conditionParam_}.sortEnd}
            </if>


            <if test="conditionParamRef.containsKey('remark')">
                <if test="conditionParamRef.remark != null and conditionParamRef.remark != ''">
                    ${_conditionType_} a.remark like #{${_conditionParam_}.remark}
                </if>
                <if test="conditionParamRef.remark == null">
                    ${_conditionType_} a.remark is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('remarkList') and conditionParamRef.remarkList.size() > 0">
                ${_conditionType_} a.remark in
                <foreach collection="conditionParamRef.remarkList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('remarkNotList') and conditionParamRef.remarkNotList.size() > 0">
                ${_conditionType_} a.remark not in
                <foreach collection="conditionParamRef.remarkNotList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('createUserId')">
                <if test="conditionParamRef.createUserId != null ">
                    ${_conditionType_} a.create_user_id = #{${_conditionParam_}.createUserId}
                </if>
                <if test="conditionParamRef.createUserId == null">
                    ${_conditionType_} a.create_user_id is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('createUserIdList') and conditionParamRef.createUserIdList.size() > 0">
                ${_conditionType_} a.create_user_id in
                <foreach collection="conditionParamRef.createUserIdList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('createUserIdNotList') and conditionParamRef.createUserIdNotList.size() > 0">
                ${_conditionType_} a.create_user_id not in
                <foreach collection="conditionParamRef.createUserIdNotList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('createUserIdStart') and conditionParamRef.createUserIdStart != null">
                ${_conditionType_} a.create_user_id <![CDATA[ >= ]]> #{${_conditionParam_}.createUserIdStart}
            </if>
            <if test="conditionParamRef.containsKey('createUserIdEnd') and conditionParamRef.createUserIdEnd != null">
                ${_conditionType_} a.create_user_id <![CDATA[ <= ]]> #{${_conditionParam_}.createUserIdEnd}
            </if>


            <if test="conditionParamRef.containsKey('createTime')">
                <if test="conditionParamRef.createTime != null ">
                    ${_conditionType_} a.create_time = #{${_conditionParam_}.createTime}
                </if>
                <if test="conditionParamRef.createTime == null">
                    ${_conditionType_} a.create_time is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('createTimeStart') and conditionParamRef.createTimeStart != null and conditionParamRef.createTimeStart!=''">
                ${_conditionType_} a.create_time <![CDATA[ >= ]]> STR_TO_DATE(left(concat(#{${_conditionParam_}.createTimeStart},' 00:00:00'),19),'%Y-%m-%d %k:%i:%s')
            </if>
            <if test="conditionParamRef.containsKey('createTimeEnd') and conditionParamRef.createTimeEnd != null and conditionParamRef.createTimeEnd!=''">
                ${_conditionType_} a.create_time <![CDATA[ <= ]]> STR_TO_DATE(left(concat(#{${_conditionParam_}.createTimeEnd},' 23:59:59'),19),'%Y-%m-%d %k:%i:%s')
            </if>

            <if test="conditionParamRef.containsKey('updateTime')">
                <if test="conditionParamRef.updateTime != null ">
                    ${_conditionType_} a.update_time = #{${_conditionParam_}.updateTime}
                </if>
                <if test="conditionParamRef.updateTime == null">
                    ${_conditionType_} a.update_time is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('updateTimeStart') and conditionParamRef.updateTimeStart != null and conditionParamRef.updateTimeStart!=''">
                ${_conditionType_} a.update_time <![CDATA[ >= ]]> STR_TO_DATE(left(concat(#{${_conditionParam_}.updateTimeStart},' 00:00:00'),19),'%Y-%m-%d %k:%i:%s')
            </if>
            <if test="conditionParamRef.containsKey('updateTimeEnd') and conditionParamRef.updateTimeEnd != null and conditionParamRef.updateTimeEnd!=''">
                ${_conditionType_} a.update_time <![CDATA[ <= ]]> STR_TO_DATE(left(concat(#{${_conditionParam_}.updateTimeEnd},' 23:59:59'),19),'%Y-%m-%d %k:%i:%s')
            </if>
    </sql>
    <sql id="_orderCols_">
        <if test="orderColList != null and !orderColList.isEmpty()">
            order by
                    <if test="conditionParamRef.containsKey('idList') and conditionParamRef.idList.size() > 0">
                        field(a.id,
                        <foreach collection="conditionParamRef.idList" open="" close=")" index="index" item="item" separator=",">
                            #{item}
                        </foreach>
                        ,
                    </if>
                    <if test="conditionParamRef.containsKey('accessIdList') and conditionParamRef.accessIdList.size() > 0">
                        field(a.accessId,
                        <foreach collection="conditionParamRef.accessIdList" open="" close=")" index="index" item="item" separator=",">
                            #{item}
                        </foreach>
                        ,
                    </if>
                    <if test="conditionParamRef.containsKey('enabledList') and conditionParamRef.enabledList.size() > 0">
                        field(a.enabled,
                        <foreach collection="conditionParamRef.enabledList" open="" close=")" index="index" item="item" separator=",">
                            #{item}
                        </foreach>
                        ,
                    </if>
                    <if test="conditionParamRef.containsKey('sortList') and conditionParamRef.sortList.size() > 0">
                        field(a.sort,
                        <foreach collection="conditionParamRef.sortList" open="" close=")" index="index" item="item" separator=",">
                            #{item}
                        </foreach>
                        ,
                    </if>
                    <if test="conditionParamRef.containsKey('createUserIdList') and conditionParamRef.createUserIdList.size() > 0">
                        field(a.createUserId,
                        <foreach collection="conditionParamRef.createUserIdList" open="" close=")" index="index" item="item" separator=",">
                            #{item}
                        </foreach>
                        ,
                    </if>
            <trim suffixOverrides=","  suffix="">
                <foreach collection="orderColList" open="" close="" index="index" item="item" separator=",">
                     a.${item.colName} ${item.sortKind}
                </foreach>
            </trim>
        </if>
        <if test="(orderColList == null or orderColList.isEmpty()) and orderCol != null and !orderCol.isEmpty()">
            order by
                    <if test="conditionParamRef.containsKey('idList') and conditionParamRef.idList.size() > 0">
                        field(a.id,
                        <foreach collection="conditionParamRef.idList" open="" close=")" index="index" item="item" separator=",">
                            #{item}
                        </foreach>
                        ,
                    </if>
                    <if test="conditionParamRef.containsKey('accessIdList') and conditionParamRef.accessIdList.size() > 0">
                        field(a.accessId,
                        <foreach collection="conditionParamRef.accessIdList" open="" close=")" index="index" item="item" separator=",">
                            #{item}
                        </foreach>
                        ,
                    </if>
                    <if test="conditionParamRef.containsKey('enabledList') and conditionParamRef.enabledList.size() > 0">
                        field(a.enabled,
                        <foreach collection="conditionParamRef.enabledList" open="" close=")" index="index" item="item" separator=",">
                            #{item}
                        </foreach>
                        ,
                    </if>
                    <if test="conditionParamRef.containsKey('sortList') and conditionParamRef.sortList.size() > 0">
                        field(a.sort,
                        <foreach collection="conditionParamRef.sortList" open="" close=")" index="index" item="item" separator=",">
                            #{item}
                        </foreach>
                        ,
                    </if>
                    <if test="conditionParamRef.containsKey('createUserIdList') and conditionParamRef.createUserIdList.size() > 0">
                        field(a.createUserId,
                        <foreach collection="conditionParamRef.createUserIdList" open="" close=")" index="index" item="item" separator=",">
                            #{item}
                        </foreach>
                        ,
                    </if>
            <trim suffixOverrides=","  suffix="">
                    <if test="orderCol.containsKey('id')">
                        a.id
                        <if test='orderCol.id != null and "DESC".equalsIgnoreCase(orderCol.id)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('accessId')">
                        a.accessId
                        <if test='orderCol.accessId != null and "DESC".equalsIgnoreCase(orderCol.accessId)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('systemName')">
                        a.system_name
                        <if test='orderCol.systemName != null and "DESC".equalsIgnoreCase(orderCol.systemName)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('systemCode')">
                        a.system_code
                        <if test='orderCol.systemCode != null and "DESC".equalsIgnoreCase(orderCol.systemCode)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('enabled')">
                        a.enabled
                        <if test='orderCol.enabled != null and "DESC".equalsIgnoreCase(orderCol.enabled)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('accessTime')">
                        a.access_time
                        <if test='orderCol.accessTime != null and "DESC".equalsIgnoreCase(orderCol.accessTime)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('sort')">
                        a.sort
                        <if test='orderCol.sort != null and "DESC".equalsIgnoreCase(orderCol.sort)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('remark')">
                        a.remark
                        <if test='orderCol.remark != null and "DESC".equalsIgnoreCase(orderCol.remark)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('createUserId')">
                        a.create_user_id
                        <if test='orderCol.createUserId != null and "DESC".equalsIgnoreCase(orderCol.createUserId)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('createTime')">
                        a.create_time
                        <if test='orderCol.createTime != null and "DESC".equalsIgnoreCase(orderCol.createTime)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('updateTime')">
                        a.update_time
                        <if test='orderCol.updateTime != null and "DESC".equalsIgnoreCase(orderCol.updateTime)'>DESC</if>
                        ,
                    </if>
            </trim>
        </if>


    </sql>
    <sql id="_group_by_">
        <if test="groupList != null and !groupList.isEmpty()">
            GROUP BY
            <trim suffixOverrides=","  suffix="">
                <foreach collection="groupList" open="" close="" index="index" item="item" separator=",">
                    ${item}
                </foreach>
            </trim>
        </if>
    </sql>
</mapper>